<script setup lang="ts">
import { ref } from 'vue';

const POSTS_PER_PAGE = 9;

const currentPage = ref(1);
const posts = ref([]);
const allPosts = ref([]);
const totalPages = ref(0);
const featuredPost = ref(null);
const targetRef = ref(null);

const { locale } = useI18n();

const { content: category } = defineProps({
  content: {
    type: Object as never,
    required: true,
  },
});

const { data } = await useAsyncData(async () => {
  const fetchedPosts = await queryContent(locale.value, `/blog/`)
    .where({ 'content.category': category.name })
    .sort({ 'content.date': -1 })
    .find();

  const featured = fetchedPosts.shift();

  return {
    featuredPost: featured,
    allPosts: fetchedPosts,
    totalPages: Math.ceil(fetchedPosts.length / POSTS_PER_PAGE),
    initialPosts: fetchedPosts.slice(0, POSTS_PER_PAGE),
  };
});

featuredPost.value = data.value.featuredPost;
allPosts.value = data.value.allPosts;
posts.value = data.value.initialPosts;
totalPages.value = data.value.totalPages;

// SEO Metadata
useGitlabSeo({
  title: `GitLab Blog Category | ${category?.name}`,
  description: `Browse articles related to ${category?.name} on the GitLab Blog`,
});

// Page Change Handler
const onPageChange = (page: number) => {
  currentPage.value = page;
  const start = POSTS_PER_PAGE * (page - 1);
  posts.value = allPosts.value.slice(start, start + POSTS_PER_PAGE);
  targetRef.value?.scrollIntoView({ behavior: 'smooth' });
};
</script>

<template>
  <div ref="targetRef">
    <BlogCategoryHero v-if="category?.name" :label="category.name" variant="category" />
    <BlogCategoryFeaturedPost v-if="featuredPost" :post="featuredPost" />
    <BlogPostGrid v-if="posts" :posts="posts" />
    <BlogPagination :total-pages="totalPages" :current-page="currentPage" @page-change="onPageChange" />
    <BlogHomeNewsLetterForm />
    <CommonGetStarted class="slp-mt-64" />
  </div>
</template>

<style lang="scss" scoped>
.featured-post {
  display: flex;
  flex-direction: column;
  gap: 32px;
  margin: 48px 0;
  background: $color-surface-800;
  border-radius: 0 0 80px 0;

  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }

  .text {
    padding: 40px 32px;
    display: flex;
    flex-direction: column;
    gap: 16px;

    .author {
      flex-basis: 100%;
    }

    .cta {
      inline-size: max-content;
    }
  }

  .image img {
    flex-shrink: 0;
    width: 100%;

    @media (min-width: $breakpoint-lg) {
      width: 560px;
      height: 100%;
      object-fit: cover;
    }
  }
}
</style>
